SystemOrganization addCategory: #Prototalk!
SystemOrganization addCategory: #'Prototalk-Tests'!

CodAMetaComponent subclass: #ProtoTalkComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Prototalk'!

!ProtoTalkComponent class methodsFor: 'as yet unclassified' stamp: 'je 1/18/2008 18:03'!
addMethod: code for: anObject
	anObject meta anonymClass compile: code! !

!ProtoTalkComponent class methodsFor: 'as yet unclassified' stamp: 'je 1/25/2008 16:28'!
at: id for: anObject
	[anObject meta anonymClass state] ifNil: [
		anObject meta anonymClass state: Dictionary new].
	^anObject meta anonymClass state at: id ifAbsent: []! !

!ProtoTalkComponent class methodsFor: 'as yet unclassified' stamp: 'je 1/25/2008 16:30'!
at: id put: value for: anObject
	[anObject meta anonymClass state] ifNil: [
		anObject meta anonymClass state: Dictionary new].
	anObject meta anonymClass state at: id put: value.! !

!ProtoTalkComponent class methodsFor: 'as yet unclassified' stamp: 'je 1/25/2008 16:55'!
installingOn: aSymbol for: anObject
	[aSymbol == #Store] ifTrue: [
		anObject meta anonymClass addInstanceVarNamed: 'slots' withValue: Dictionary new.].
	anObject meta anonymClass compile: 'slots
	^slots'.
	anObject meta anonymClass compile: 'slots: val
	slots := val'! !

!ProtoTalkComponent class methodsFor: 'as yet unclassified' stamp: 'je 1/18/2008 18:54'!
methodFor: aMessage for: anObject
	^ anObject meta anonymClass compiledMethodAt: aMessage selector ifAbsent: [
		anObject meta oldObject class allCompiledMethodsAt: aMessage selector ]! !

!ProtoTalkComponent class methodsFor: 'as yet unclassified' stamp: 'je 1/25/2008 16:32'!
slotIdsFor: anObject
	[anObject meta anonymClass state] ifNil: [
		anObject meta anonymClass state: Dictionary new].
	^anObject meta anonymClass state keys.! !

!Object methodsFor: '*prototalk' stamp: 'je 1/25/2008 17:02'!
addMethod: code
	self meta protocol = ProtoTalkComponent ifFalse: [
		self meta install: ProtoTalkComponent at: #Protocol for: self ].
	self meta protocol addMethod: code for: self! !

!Object methodsFor: '*prototalk' stamp: 'je 1/25/2008 17:37'!
protoClone
	| clone |
	clone := Object new.
	clone meta install: ProtoTalkComponent at: #Protocol for: clone.
	clone meta install: ProtoTalkComponent at: #State for: clone.
	clone meta state at: #prototype put: self.
	self class instVarNames do: [ :name | clone meta state at: name asSymbol put: (self instVarAt: name)].
	^clone! !

!Class methodsFor: '*prototalk' stamp: 'je 1/18/2008 18:53'!
allCompiledMethodsAt: aSelector
	self compiledMethodAt: aSelector ifPresent: [ :method | ^method].
	self allSuperclassesDo: [ :superClass |
		superClass compiledMethodAt: aSelector ifPresent: [ :method| ^method]].
	Error signal: 'key not found'! !

!Class methodsFor: '*prototalk' stamp: 'je 1/18/2008 18:54'!
compiledMethodAt: aSelector ifPresent: aBlock
	^self methodDict at: aSelector ifPresent: aBlock! !

TestCase subclass: #ProtoTalkTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Prototalk-Tests'!

!ProtoTalkTest methodsFor: 'as yet unclassified' stamp: 'je 1/18/2008 18:38'!
testObjectMethods
	| o1 |
	o1 := 'Juri'.
	o1 addMethod: 'huhu
'.

	self shouldnt: [o1 huhu] raise: MessageNotUnderstood.
	self shouldnt: [o1 at: 1] raise: Error.
! !
